package db

import (
	"applet/app/db/model"
	"applet/app/utils/logx"
	"xorm.io/xorm"
)

// 获取拉新奖励记录
func GetNewAcquisitionRewardLog(Db *xorm.Engine, condition *model.NewAcquisitionRewardLog) (*model.NewAcquisitionRewardLog, bool, error) {
	r := new(model.NewAcquisitionRewardLog)
	has, err := Db.Get(condition)
	if err != nil {
		return r, false, err
	}
	return condition, has, nil
}
func GetNewAcquisitionRewardLogWhere(Db *xorm.Engine, uid, toUid, lv int) (*model.NewAcquisitionRewardLog, bool, error) {
	var data model.NewAcquisitionRewardLog
	has, err := Db.Where("uid=? and to_uid=? and lv=?", uid, toUid, lv).Get(&data)
	if err != nil {
		return nil, false, err
	}
	return &data, has, nil
}

// 获取拉新记录
func GetNewAcquisitionLog(Db *xorm.Engine, condition *model.NewAcquisitionLog) (*model.NewAcquisitionLog, bool, error) {
	r := new(model.NewAcquisitionLog)
	has, err := Db.Get(condition)
	if err != nil {
		return r, false, err
	}
	return condition, has, nil
}

// 插入奖励记录
func InsertNewRewardLog(Db *xorm.Engine, rewardLog *model.NewAcquisitionRewardLog) {
	row, err := Db.InsertOne(rewardLog)
	if err != nil || row == 0 {
		_ = logx.Warn(err)
	}
}
