package db

import (
	"applet/app/db/model"
	"applet/app/utils"
	"errors"
	"github.com/syyongx/php2go"
	"strings"

	"xorm.io/xorm"
)

// FreeProductByID is 获取新人免单对应的商品id
func FreeProductByID(Db *xorm.Engine, gid, provider string) (*model.NewcomersFreeProduct, error) {
	m := new(model.NewcomersFreeProduct)
	var has bool
	var err error
	if utils.InArr(provider, []string{"taobao", "tmall"}) && php2go.IsNumeric(gid) == false {
		gidArr := strings.Split(gid, "-")
		if len(gidArr) == 2 {
			gid = gidArr[1]
		}
		has, err = Db.Where("good_id LIKE ?", "%-"+gid).Get(m)
	} else {
		m.GoodId = gid
		has, err = Db.Get(m)
	}

	if err != nil {
		return nil, err
	}
	if !has {
		return nil, errors.New("Not Found")
	}

	return m, nil
}
