package model

type OrdList struct {
	OrdId                    int64   `xorm:"pk autoincr BIGINT(20)" json:"ord_id"`
	Uid                      int     `xorm:"not null index INT(10)" json:"uid"`
	PvdOid                   string  `xorm:"not null index(IDX_PVD) VARCHAR(50)" json:"pvd_oid"`
	ParentOrdId              int64   `xorm:" BIGINT(20)" json:"parent_ord_id"`
	Pvd                      string  `xorm:"not null default '' index(IDX_PVD) index(IDX_PVD_ITEM) VARCHAR(8)" json:"pvd"`
	ItemId                   string  `xorm:"not null default '' index(IDX_PVD_ITEM) VARCHAR(50)" json:"item_id"`
	ItemNum                  int     `xorm:"not null default 1 TINYINT(3)" json:"item_num"`
	ItemPrice                float64 `xorm:"not null default 0.00 DOUBLE(10,2)" json:"item_price"`
	ItemCommissionRate       float64 `xorm:"not null default 0.00 DOUBLE(6,4)" json:"item_commission_rate"`
	PaidPrice                float64 `xorm:"not null default 0.00 DOUBLE(10,2)" json:"paid_price"`
	OrderType                int     `xorm:"not null default 0 TINYINT(1)" json:"order_type"`
	PriceType                int     `xorm:"not null default 0 INT(1)" json:"price_type"`
	OrderCompare             int     `xorm:"not null default 0 TINYINT(1)" json:"order_compare"`
	SubsidyFee               float64 `xorm:"not null default 0.00 DOUBLE(8,2)" json:"subsidy_fee"`
	SubsidyRate              float64 `xorm:"not null default 0.0000 DOUBLE(10,4)" json:"subsidy_rate"`
	UserCommission           float64 `xorm:"not null default 0.000 DOUBLE(8,3)" json:"user_commission"`
	UserReturnMoney          float64 `xorm:"not null default 0.000 DOUBLE(8,3)" json:"user_return_money"`
	UserCommissionRate       float64 `xorm:"not null default 0.0000 DOUBLE(6,4)" json:"user_commission_rate"`
	PvdCommission            float64 `xorm:"not null default 0.0000 DOUBLE(8,4)" json:"pvd_commission"`
	PvdCommissionRate        float64 `xorm:"not null default 0.0000 DOUBLE(6,4)" json:"pvd_commission_rate"`
	SysCommission            float64 `xorm:"not null default 0.0000 DOUBLE(8,4)" json:"sys_commission"`
	SysCommissionRate        float64 `xorm:"not null default 0.0000 DOUBLE(6,4)" json:"sys_commission_rate"`
	PlanCommissionId         int     `xorm:"not null default 0 INT(10)" json:"plan_commission_id"`
	PlanCommissionState      int     `xorm:"not null default 0 TINYINT(1)" json:"plan_commission_state"`
	Reason                   string  `xorm:"not null default '' VARCHAR(32)" json:"reason"`
	State                    int     `xorm:"not null default 0 TINYINT(1)" json:"state"`
	LockState                int     `xorm:"not null default 0 TINYINT(1)" json:"lock_state"`
	CreateAt                 int     `xorm:"not null default 0 INT(10)" json:"create_at"`
	UpdateAt                 int     `xorm:"not null default 0 INT(11)" json:"update_at"`
	ConfirmAt                int     `xorm:"not null default 0 INT(10)" json:"confirm_at"`
	CheckSuccessAt           int     `xorm:"not null default 0 INT(10)" json:"check_success_at"`
	PvdSettleAt              int     `xorm:"not null default 0 INT(10)" json:"pvd_settle_at"`
	SettleAt                 int     `xorm:"not null default 0 INT(10)" json:"settle_at"`
	ReturnMoneySettleAt      int     `xorm:"not null default 0 INT(10)" json:"return_money_settle_at"`
	SubsidyAt                int     `xorm:"not null default 0 INT(10)" json:"subsidy_at"`
	BenefitList              string  `xorm:"not null default '' index VARCHAR(200)" json:"benefit_list"`
	BenefitAll               float64 `xorm:"not null default 0.00 DOUBLE(10,3)" json:"benefit_all"`
	Data                     string  `xorm:"not null default '' VARCHAR(2000)" json:"data"`
	UpdateFrom               int     `xorm:"not null default 0 TINYINT(1)" json:"update_from"`
	CreateFrom               int     `xorm:"not null default 0 TINYINT(1)" json:"create_from"`
	IsRefund                 int     `xorm:"not null default 0 INT(1)" json:"is_refund"`
	IsSendMsg                int     `xorm:"not null default 0 INT(1)" json:"is_send_msg"`
	PvdPid                   string  `xorm:"not null default '' VARCHAR(100)" json:"pvd_pid"`
	CostPrice                float64 `xorm:"not null default 0.00 FLOAT(10,2)" json:"cost_price"`
	PlatformData             string  `xorm:"TEXT" json:"platform_data"`
	IsTikTokTeamOrder        int     `xorm:"not null default 0 INT(1)" json:"is_tik_tok_team_order"`
	TikTokTeamCommission     string  `json:"tik_tok_team_commission" xorm:"not null default 0.00 comment('') DECIMAL(20,8)"`
	IsFastSign               int     `xorm:"not null default 0 INT(1)" json:"is_fast_sign"`
	IsWaitReduce             int     `xorm:"not null default 0 INT(1)" json:"is_wait_reduce"`
	FastSignId               string  `xorm:"not null default '' VARCHAR(100)" json:"fast_sign_id"`
	TransferSignId           string  `xorm:"not null default '' VARCHAR(100)" json:"transfer_sign_id"`
	IsTransfer               int     `xorm:"not null default 0 INT(1)" json:"is_transfer"`
	FastSuccess              int     `xorm:"not null default 0 INT(1)" json:"fast_success"`
	BuckleCommission         string  `json:"buckle_commission" xorm:"DECIMAL(20,2)"`
	OrderFormType            int     `xorm:"not null default 0 INT(1)" json:"order_form_type"`
	HjyOid                   int     `xorm:"not null default 0 INT(11)" json:"hjy_oid"`
	TikTokTeamRealCommission string  `json:"tik_tok_team_real_commission" xorm:"not null default 0.00 comment('') DECIMAL(20,8)"`
}
